# Chapter6.py
# Collection Classes
# Lists, Sets, Tuples, Dict non dimension structural
# 1 Dim, 2 Dim, 3 Dim dataframes dimensional data DISCUSSION

'''
unstructured data txt,doc,md,... file

structured data   value with type
property > variable name with data type "firstName as string" and assigning a value "Bob" prop/element/item "singular instance of data"
"Collect instances of data" > Collection Class
data in a collection class is INDEPENDENT of eachother
"Bob","Smith",21,True,True,2024-12-15 12:00:00.000000

4 Collection Classes IN OOP (Level 1 and Level 2)
List [] indexed, mutatable, dups, single, others...
Set {} !indexed, change, !sorted, !dups, single, ...
Tuple () positionalIds, immutable, tuple>list>tuple
Dictionary/Map { key: value } key!dup:valuesDup, Key<immutable>: Value{mutatable}

dimensional data (Level 3) Python pandas DataFrames
1 Dim Series Array DEPENDENT col <value>
2 Dim row,col  <value>
3 Dim pivot1 -> row,col <value>
4 Dim pivot2 -> pivot1 -> row,col <value>
4 Dim pivot2,pivot1 -> row,col <value>
...
7 Dim p5,p4,p3,p2,p1 -> row, col <value>
'''

# the for loop in Python Core
# for x in ys ## option 1 basic loop
# x is the local variable in the scope
# ys in the data set aka where are you getting your values

# option 2 in range()
# option 3 Pythonic in enumerate()  enumerator "best option"
# option 4 "special option" in zip() unpack objects Pythonic tuples


# page 164 list
firstNames = ["Bob","Joe","Mary"]
print("##### List with loop ######")
print(firstNames) # List []
for firstName in firstNames:
    print(firstName)
# control, condition, print(), increment, break



### Ask the user for a new firstName input() ###
newContact = input("Enter a new contact first name: ")

### Append the new firstName to the firstNames list append() ###
firstNames.append(newContact)
print(firstNames) # List []
for firstName in firstNames:
    print(firstName)

# page 194 tuples
firstNames = ("Bob","Joe","Mary")

print("##### Tuple with loop ######")
print(firstNames) # Tuple ()
for firstName in firstNames:
    print(firstName)
# control, condition, print(), increment, break

# Using enumerate() page 170
firstNames = ["Bob","Joe","Mary"]
print("##### List with enumerate ######")
print("Select Contact to update: ")
for index,firstName in enumerate(firstNames):
    print(f"Index ID: {index + 1} First Name: {firstName}")
