# Chapter3.py
# relational ops page 67
# == testing value >= <= > < !=
# a-zA-Z0-9[chars]  Bob < bob false

# logical ops page 69
# not and or

# Global
if_string2 = "You can not vote, drink or retire"

# if you are going to combine a relational with a logical you must repeat the variable to test
# ((age > 18 and age < 21) or state == 'Florida')
# (age > 18 and state == 'Florida')
# int(age)
''' Example of line breaking functions
int(
    input("Enter your age: " ).startswith(
        input("Char to test: ") #input
    ) # input
) # int
'''
# store it as type use
input_age = int(input("Enter your age: ")) # int [0-9]
# firstName = input("Enter your name: ").title()
#  pattern = ^[A-Z]*$

# validation
# if statement page 73


if input_age < 0 or input_age > 120:
    print("You entered an invalid age. Please enter an age between 0 and 120.")
    # Loop them back to the input() while true
else:    # False
    string1 = "Voting Drink and Retirement Age Test."
    # ['V','o','t',....] Collection Structural
    print(string1) # functional(object)
    # nested if to test < 18 nothing >=18 <21 vote
    if input_age < 18:
        #if_string2 = "You can not vote, drink or retire"
        print(if_string2) # calling the global NOT local scope
        # break is built in to the statement
    elif (input_age >= 18 and input_age < 21):
        # pass - placeholder for no code
        print("You can vote, but not drink or retire")
    elif (input_age >= 21 and input_age < 65): 
        print("You can vote and drink, but not retire")
    elif (input_age >= 65 and input_age <= 120):   
        print("You can vote, drink and retire")
    else: # False
        else_string2 = "this is the false return." # setters
        print(else_string2) # getters

# DRY Principle of Software Development
# Law of Demeter Principle of Software Development

print("##### Match Example #####")
# match case aka "switch/case"
# match is available in 3.10 and above
# need to update VS Code to 2022 or above
match input_age: # switch input_age case/default
    case input_age if input_age > 0 and input_age < 18:
        print(if_string2)
    case input_age if input_age >= 18 and input_age < 21:
        print("18 to 21")
    case input_age if input_age >= 21 and input_age < 65:
        print("21 to 65")
    case input_age if input_age >= 65 and input_age <= 120:
        print("65 to 120")
    case _: # replaces default
        print("!valid entry")
