# Chapter4.py 

# Functions
# Step 1 Define Function
## pass data thru function (param1, param2, param3=12)
# Step 2 Call Function
## assign the value to pass (arg1, arg2)
## ('Bob','Smith')
# In Python, default values must follow static values

# Application Accounting/Order
# Factory Container
# PROVIDERS ADMIN  CUSTOMER
# Service ADMIN.Desktop  CUSTOMER.App<Web/Phone>
# Class CUSTOMER.App.Customers
# Object CUSTOMER.APP.Customers.GetCustomers() Dinner
# Customers.Customer  Salad
# Customer.FN, Customer.LN, ... Bob, Smith  Salt/Pepper
### Bob? string of chars ['B','o','b'] Salt
### 'B' ASCII 01000010  NACL
### bit assigned 0 or 1  element  H,O,NA,CL
####### view output return ######

# Ask these 3 things
# Did I define it?
# Did I give it value?
# Did I return it?
## function -> themself
## method -> something else  "return"

# Python def funcName()
# Angular function funcName()  func funcName()
# MyApplication.py
# MyFunctions.py

''' Empty Function Example

# Define a function that has variables inside the scope
# Empty Function
def fullName():
    firstName = "Bob"
    lastName = "Smith"
    age = 40
    # 2 ways to output "Bob Smith"
    fullName1 = firstName + " " + lastName + " " + str(age) # Join -> data types matter
    # print("Full Name using join: " + fullName1)
    # string interpolation with the f keyword and template variables -> types are ignored only looks value
    fullName2 = f"FullName using template vars: {lastName}, {firstName} >>> {age}."
    #print(fullName2) 
    return fullName2 # access to fullName2 outside scope

# the program does not have access to fullName1 or fullName2 at this point
# fullName() # calling the function and output fullName1 scope

appFullName2 = fullName() # local var = return value
print(appFullName2) # printing the output of local var

''' 

# Parameterized Function
# Pass variables to the function to use inside the scope

##################  DATA SOURCE ##################
firstName = "Bob"
lastName = "Smith"

###################################################

# Expected x but got y
# Expected 2 variables to get passed, but got <> 2

def fullName(firstName, lastName): # expecting 2 params
    ### Assigning local vars in scope function ###
    fName = firstName
    lName = lastName
    vipStatus = True
    ###

    # Using the local vars in the function for operations
    fullName = fName + " " + lName
    return lName, fullName, vipStatus # Doe, Jane Doe

######## Runs at runtime ###############

# Menu of Contact Last Names  lname_returned
lName_returned, fullName_returned, vipStatus_returned = fullName("Jane", "Doe")
print(vipStatus_returned)
# Contact Information
print(fullName_returned) # Jane Doe
print(lName_returned) # Doe
initials = lName_returned[0]
print(initials)  # D

# Singular Assignment from a return
all_ThreeReturns = fullName("Mary", "Johnson") 
print(all_ThreeReturns)

